using JetBrains.ReSharper.Daemon;
using JetBrains.ReSharper.Psi.Tree;
using ReSharper.Framework;

namespace ReSharper.CatchExceptions {
  /// <summary>
  /// Represents a GenerateAssertionsElementProcessor.
  /// </summary>
  // [DaemonStage]
  public class Highlighter: HighlighterBase {
    #region Constructor

    /// <summary>
    /// Initializes a new instance of the <see cref="Highlighter"/> class.
    /// </summary>
    public Highlighter() {
    }

    /// <summary>
    /// Initializes a new instance of the <see cref="Highlighter"/> class.
    /// </summary>
    /// <param name="daemonProcess">The daemon process.</param>
    public Highlighter(IDaemonProcess daemonProcess) : base(daemonProcess) {
    }

    #endregion

    #region Protected methods

    /// <summary>
    /// Run after the interior has run.
    /// </summary>
    /// <param name="element">The element.</param>
    protected override void ProcessElement(IElement element) {
      if(ContextAction.IsVisible(element)){
        HighlightingBase highlighting = new HighlightingBase(element, "Statement throws exceptions.");

        AddHighlighting(highlighting);
      }
    }

    #endregion
  }
}