using JetBrains.ReSharper.Daemon;
using JetBrains.ReSharper.ProjectModel;
using JetBrains.ReSharper.Psi.Tree;
using JetBrains.ReSharper.TextControl;
using ReSharper.Framework;

namespace ReSharper.IntroduceStringConstant {
  /// <summary>
  /// Implements a Generate Assertions powertoy plugin.
  /// </summary>
  [ContextAction(Name = "IntroduceStringConstant")]
  public class ContextAction : ContextActionBase {
    #region Constructor

    /// <summary>
    /// Initializes a new instance of the <see cref="ContextAction"/> class.
    /// </summary>
    /// <param name="solution">The solution.</param>
    /// <param name="textControl">The text control.</param>
    public ContextAction(ISolution solution, ITextControl textControl) : base(solution, textControl) {
    }

    #endregion

    #region Protected methods

    /// <summary>
    /// Executes this instance.
    /// </summary>
    /// <param name="element">The element.</param>
    protected override void Execute(IElement element) {
      Refactoring refactoring = new Refactoring(Solution, TextControl);

      refactoring.Execute();
    }

    /// <summary>
    /// Gets the text.
    /// </summary>
    /// <returns>The text.</returns>
    protected override string GetText() {
      return "Introduce String Constant";
    }

    /// <summary>
    /// Determines whether this instance is available.
    /// </summary>
    /// <param name="element">The element.</param>
    /// <returns>
    /// 	<c>true</c> if this instance is available; otherwise, <c>false</c>.
    /// </returns>
    protected override bool IsAvailable(IElement element) {
      return Refactoring.IsAvailable(element);
    }

    #endregion

  }
}
